<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>Porting Python 2 Code to Python 3 &mdash; Python 3.5.1 documentation</title>
    
    <link rel="stylesheet" href="../_static/pydoctheme.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '3.5.1',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/sidebar.js"></script>
    <link rel="search" type="application/opensearchdescription+xml"
          title="Search within Python 3.5.1 documentation"
          href="../_static/opensearch.xml"/>
    <link rel="author" title="About these documents" href="../about.html" />
    <link rel="copyright" title="Copyright" href="../copyright.html" />
    <link rel="top" title="Python 3.5.1 documentation" href="../contents.html" />
    <link rel="up" title="Python HOWTOs" href="index.html" />
    <link rel="next" title="Porting Extension Modules to Python 3" href="cporting.html" />
    <link rel="prev" title="Python HOWTOs" href="index.html" />
    <link rel="shortcut icon" type="image/png" href="../_static/py.png" />
    <script type="text/javascript" src="../_static/copybutton.js"></script>
    <script type="text/javascript" src="../_static/version_switch.js"></script>
    
 

  </head>
  <body role="document">  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="cporting.html" title="Porting Extension Modules to Python 3"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="index.html" title="Python HOWTOs"
             accesskey="P">previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" accesskey="U">Python HOWTOs</a> &raquo;</li> 
      </ul>
    </div>    

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="porting-python-2-code-to-python-3">
<span id="pyporting-howto"></span><h1>Porting Python 2 Code to Python 3<a class="headerlink" href="#porting-python-2-code-to-python-3" title="Permalink to this headline">¶</a></h1>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">author:</th><td class="field-body">Brett Cannon</td>
</tr>
</tbody>
</table>
<div class="topic">
<p class="topic-title first">Abstract</p>
<p>With Python 3 being the future of Python while Python 2 is still in active
use, it is good to have your project available for both major releases of
Python. This guide is meant to help you figure out how best to support both
Python 2 &amp; 3 simultaneously.</p>
<p>If you are looking to port an extension module instead of pure Python code,
please see <a class="reference internal" href="cporting.html#cporting-howto"><span>Porting Extension Modules to Python 3</span></a>.</p>
<p>If you would like to read one core Python developer&#8217;s take on why Python 3
came into existence, you can read Nick Coghlan&#8217;s <a class="reference external" href="http://ncoghlan-devs-python-notes.readthedocs.org/en/latest/python3/questions_and_answers.html">Python 3 Q &amp; A</a>.</p>
<p>For help with porting, you can email the <a class="reference external" href="https://mail.python.org/mailman/listinfo/python-porting">python-porting</a> mailing list with
questions.</p>
</div>
<div class="section" id="the-short-explanation">
<h2>The Short Explanation<a class="headerlink" href="#the-short-explanation" title="Permalink to this headline">¶</a></h2>
<p>To make your project be single-source Python 2/3 compatible, the basic steps
are:</p>
<ol class="arabic simple">
<li>Only worry about supporting Python 2.7</li>
<li>Make sure you have good test coverage (<a class="reference external" href="https://pypi.python.org/pypi/coverage">coverage.py</a> can help;
<code class="docutils literal"><span class="pre">pip</span> <span class="pre">install</span> <span class="pre">coverage</span></code>)</li>
<li>Learn the differences between Python 2 &amp; 3</li>
<li>Use <a class="reference external" href="http://python-modernize.readthedocs.org/en/latest/">Modernize</a> or <a class="reference external" href="http://python-future.org/automatic_conversion.html">Futurize</a> to update your code (<code class="docutils literal"><span class="pre">pip</span> <span class="pre">install</span> <span class="pre">modernize</span></code> or
<code class="docutils literal"><span class="pre">pip</span> <span class="pre">install</span> <span class="pre">future</span></code>, respectively)</li>
<li>Use <a class="reference external" href="https://pypi.python.org/pypi/pylint">Pylint</a> to help make sure you don&#8217;t regress on your Python 3 support
(<code class="docutils literal"><span class="pre">pip</span> <span class="pre">install</span> <span class="pre">pylint</span></code>)</li>
<li>Use <a class="reference external" href="https://pypi.python.org/pypi/caniusepython3">caniusepython3</a> to find out which of your dependencies are blocking your
use of Python 3 (<code class="docutils literal"><span class="pre">pip</span> <span class="pre">install</span> <span class="pre">caniusepython3</span></code>)</li>
<li>Once your dependencies are no longer blocking you, use continuous integration
to make sure you stay compatible with Python 2 &amp; 3 (<a class="reference external" href="https://pypi.python.org/pypi/tox">tox</a> can help test
against multiple versions of Python; <code class="docutils literal"><span class="pre">pip</span> <span class="pre">install</span> <span class="pre">tox</span></code>)</li>
</ol>
<p>If you are dropping support for Python 2 entirely, then after you learn the
differences between Python 2 &amp; 3 you can run <a class="reference external" href="https://docs.python.org/3/library/2to3.html">2to3</a> over your code and skip the
rest of the steps outlined above.</p>
</div>
<div class="section" id="details">
<h2>Details<a class="headerlink" href="#details" title="Permalink to this headline">¶</a></h2>
<p>A key point about supporting Python 2 &amp; 3 simultaneously is that you can start
<strong>today</strong>! Even if your dependencies are not supporting Python 3 yet that does
not mean you can&#8217;t modernize your code <strong>now</strong> to support Python 3. Most changes
required to support Python 3 lead to cleaner code using newer practices even in
Python 2.</p>
<p>Another key point is that modernizing your Python 2 code to also support
Python 3 is largely automated for you. While you might have to make some API
decisions thanks to Python 3 clarifying text data versus binary data, the
lower-level work is now mostly done for you and thus can at least benefit from
the automated changes immediately.</p>
<p>Keep those key points in mind while you read on about the details of porting
your code to support Python 2 &amp; 3 simultaneously.</p>
<div class="section" id="drop-support-for-python-2-6-and-older">
<h3>Drop support for Python 2.6 and older<a class="headerlink" href="#drop-support-for-python-2-6-and-older" title="Permalink to this headline">¶</a></h3>
<p>While you can make Python 2.5 work with Python 3, it is <strong>much</strong> easier if you
only have to work with Python 2.7. If dropping Python 2.5 is not an
option then the <a class="reference external" href="https://pypi.python.org/pypi/six">six</a> project can help you support Python 2.5 &amp; 3 simultaneously
(<code class="docutils literal"><span class="pre">pip</span> <span class="pre">install</span> <span class="pre">six</span></code>). Do realize, though, that nearly all the projects listed
in this HOWTO will not be available to you.</p>
<p>If you are able to skip Python 2.5 and older, then the required changes
to your code should continue to look and feel like idiomatic Python code. At
worst you will have to use a function instead of a method in some instances or
have to import a function instead of using a built-in one, but otherwise the
overall transformation should not feel foreign to you.</p>
<p>But you should aim for only supporting Python 2.7. Python 2.6 is no longer
supported and thus is not receiving bugfixes. This means <strong>you</strong> will have to
work around any issues you come across with Python 2.6. There are also some
tools mentioned in this HOWTO which do not support Python 2.6 (e.g., <a class="reference external" href="https://pypi.python.org/pypi/pylint">Pylint</a>),
and this will become more commonplace as time goes on. It will simply be easier
for you if you only support the versions of Python that you have to support.</p>
</div>
<div class="section" id="make-sure-you-specify-the-proper-version-support-in-your-setup-py-file">
<h3>Make sure you specify the proper version support in your <code class="docutils literal"><span class="pre">setup.py</span></code> file<a class="headerlink" href="#make-sure-you-specify-the-proper-version-support-in-your-setup-py-file" title="Permalink to this headline">¶</a></h3>
<p>In your <code class="docutils literal"><span class="pre">setup.py</span></code> file you should have the proper <a class="reference external" href="https://pypi.python.org/pypi?%3Aaction=list_classifiers">trove classifier</a>
specifying what versions of Python you support. As your project does not support
Python 3 yet you should at least have
<code class="docutils literal"><span class="pre">Programming</span> <span class="pre">Language</span> <span class="pre">::</span> <span class="pre">Python</span> <span class="pre">::</span> <span class="pre">2</span> <span class="pre">::</span> <span class="pre">Only</span></code> specified. Ideally you should
also specify each major/minor version of Python that you do support, e.g.
<code class="docutils literal"><span class="pre">Programming</span> <span class="pre">Language</span> <span class="pre">::</span> <span class="pre">Python</span> <span class="pre">::</span> <span class="pre">2.7</span></code>.</p>
</div>
<div class="section" id="have-good-test-coverage">
<h3>Have good test coverage<a class="headerlink" href="#have-good-test-coverage" title="Permalink to this headline">¶</a></h3>
<p>Once you have your code supporting the oldest version of Python 2 you want it
to, you will want to make sure your test suite has good coverage. A good rule of
thumb is that if you want to be confident enough in your test suite that any
failures that appear after having tools rewrite your code are actual bugs in the
tools and not in your code. If you want a number to aim for, try to get over 80%
coverage (and don&#8217;t feel bad if you can&#8217;t easily get past 90%). If you
don&#8217;t already have a tool to measure test coverage then <a class="reference external" href="https://pypi.python.org/pypi/coverage">coverage.py</a> is
recommended.</p>
</div>
<div class="section" id="learn-the-differences-between-python-2-3">
<h3>Learn the differences between Python 2 &amp; 3<a class="headerlink" href="#learn-the-differences-between-python-2-3" title="Permalink to this headline">¶</a></h3>
<p>Once you have your code well-tested you are ready to begin porting your code to
Python 3! But to fully understand how your code is going to change and what
you want to look out for while you code, you will want to learn what changes
Python 3 makes in terms of Python 2. Typically the two best ways of doing that
is reading the <a class="reference external" href="https://docs.python.org/3/whatsnew/index.html">&#8220;What&#8217;s New&#8221;</a> doc for each release of Python 3 and the
<a class="reference external" href="http://python3porting.com/">Porting to Python 3</a> book (which is free online). There is also a handy
<a class="reference external" href="http://python-future.org/compatible_idioms.html">cheat sheet</a> from the Python-Future project.</p>
</div>
<div class="section" id="update-your-code">
<h3>Update your code<a class="headerlink" href="#update-your-code" title="Permalink to this headline">¶</a></h3>
<p>Once you feel like you know what is different in Python 3 compared to Python 2,
it&#8217;s time to update your code! You have a choice between two tools in porting
your code automatically: <a class="reference external" href="http://python-modernize.readthedocs.org/en/latest/">Modernize</a> and <a class="reference external" href="http://python-future.org/automatic_conversion.html">Futurize</a>. Which tool you choose will
depend on how much like Python 3 you want your code to be. <a class="reference external" href="http://python-future.org/automatic_conversion.html">Futurize</a> does its
best to make Python 3 idioms and practices exist in Python 2, e.g. backporting
the <code class="docutils literal"><span class="pre">bytes</span></code> type from Python 3 so that you have semantic parity between the
major versions of Python. <a class="reference external" href="http://python-modernize.readthedocs.org/en/latest/">Modernize</a>,
on the other hand, is more conservative and targets a Python 2/3 subset of
Python, relying on <a class="reference external" href="https://pypi.python.org/pypi/six">six</a> to help provide compatibility.</p>
<p>Regardless of which tool you choose, they will update your code to run under
Python 3 while staying compatible with the version of Python 2 you started with.
Depending on how conservative you want to be, you may want to run the tool over
your test suite first and visually inspect the diff to make sure the
transformation is accurate. After you have transformed your test suite and
verified that all the tests still pass as expected, then you can transform your
application code knowing that any tests which fail is a translation failure.</p>
<p>Unfortunately the tools can&#8217;t automate everything to make your code work under
Python 3 and so there are a handful of things you will need to update manually
to get full Python 3 support (which of these steps are necessary vary between
the tools). Read the documentation for the tool you choose to use to see what it
fixes by default and what it can do optionally to know what will (not) be fixed
for you and what you may have to fix on your own (e.g. using <code class="docutils literal"><span class="pre">io.open()</span></code> over
the built-in <code class="docutils literal"><span class="pre">open()</span></code> function is off by default in Modernize). Luckily,
though, there are only a couple of things to watch out for which can be
considered large issues that may be hard to debug if not watched for.</p>
<div class="section" id="division">
<h4>Division<a class="headerlink" href="#division" title="Permalink to this headline">¶</a></h4>
<p>In Python 3, <code class="docutils literal"><span class="pre">5</span> <span class="pre">/</span> <span class="pre">2</span> <span class="pre">==</span> <span class="pre">2.5</span></code> and not <code class="docutils literal"><span class="pre">2</span></code>; all division between <code class="docutils literal"><span class="pre">int</span></code> values
result in a <code class="docutils literal"><span class="pre">float</span></code>. This change has actually been planned since Python 2.2
which was released in 2002. Since then users have been encouraged to add
<code class="docutils literal"><span class="pre">from</span> <span class="pre">__future__</span> <span class="pre">import</span> <span class="pre">division</span></code> to any and all files which use the <code class="docutils literal"><span class="pre">/</span></code> and
<code class="docutils literal"><span class="pre">//</span></code> operators or to be running the interpreter with the <code class="docutils literal"><span class="pre">-Q</span></code> flag. If you
have not been doing this then you will need to go through your code and do two
things:</p>
<ol class="arabic simple">
<li>Add <code class="docutils literal"><span class="pre">from</span> <span class="pre">__future__</span> <span class="pre">import</span> <span class="pre">division</span></code> to your files</li>
<li>Update any division operator as necessary to either use <code class="docutils literal"><span class="pre">//</span></code> to use floor
division or continue using <code class="docutils literal"><span class="pre">/</span></code> and expect a float</li>
</ol>
<p>The reason that <code class="docutils literal"><span class="pre">/</span></code> isn&#8217;t simply translated to <code class="docutils literal"><span class="pre">//</span></code> automatically is that if
an object defines a <code class="docutils literal"><span class="pre">__truediv__</span></code> method but not <code class="docutils literal"><span class="pre">__floordiv__</span></code> then your
code would begin to fail (e.g. a user-defined class that uses <code class="docutils literal"><span class="pre">/</span></code> to
signify some operation but not <code class="docutils literal"><span class="pre">//</span></code> for the same thing or at all).</p>
</div>
<div class="section" id="text-versus-binary-data">
<h4>Text versus binary data<a class="headerlink" href="#text-versus-binary-data" title="Permalink to this headline">¶</a></h4>
<p>In Python 2 you could use the <code class="docutils literal"><span class="pre">str</span></code> type for both text and binary data.
Unfortunately this confluence of two different concepts could lead to brittle
code which sometimes worked for either kind of data, sometimes not. It also
could lead to confusing APIs if people didn&#8217;t explicitly state that something
that accepted <code class="docutils literal"><span class="pre">str</span></code> accepted either text or binary data instead of one
specific type. This complicated the situation especially for anyone supporting
multiple languages as APIs wouldn&#8217;t bother explicitly supporting <code class="docutils literal"><span class="pre">unicode</span></code>
when they claimed text data support.</p>
<p>To make the distinction between text and binary data clearer and more
pronounced, Python 3 did what most languages created in the age of the internet
have done and made text and binary data distinct types that cannot blindly be
mixed together (Python predates widespread access to the internet). For any code
that only deals with text or only binary data, this separation doesn&#8217;t pose an
issue. But for code that has to deal with both, it does mean you might have to
now care about when you are using text compared to binary data, which is why
this cannot be entirely automated.</p>
<p>To start, you will need to decide which APIs take text and which take binary
(it is <strong>highly</strong> recommended you don&#8217;t design APIs that can take both due to
the difficulty of keeping the code working; as stated earlier it is difficult to
do well). In Python 2 this means making sure the APIs that take text can work
with <code class="docutils literal"><span class="pre">unicode</span></code> in Python 2 and those that work with binary data work with the
<code class="docutils literal"><span class="pre">bytes</span></code> type from Python 3 and thus a subset of <code class="docutils literal"><span class="pre">str</span></code> in Python 2 (which the
<code class="docutils literal"><span class="pre">bytes</span></code> type in Python 2 is an alias for). Usually the biggest issue is
realizing which methods exist for which types in Python 2 &amp; 3 simultaneously
(for text that&#8217;s <code class="docutils literal"><span class="pre">unicode</span></code> in Python 2 and <code class="docutils literal"><span class="pre">str</span></code> in Python 3, for binary
that&#8217;s <code class="docutils literal"><span class="pre">str</span></code>/<code class="docutils literal"><span class="pre">bytes</span></code> in Python 2 and <code class="docutils literal"><span class="pre">bytes</span></code> in Python 3). The following
table lists the <strong>unique</strong> methods of each data type across Python 2 &amp; 3
(e.g., the <code class="docutils literal"><span class="pre">decode()</span></code> method is usable on the equivalent binary data type in
either Python 2 or 3, but it can&#8217;t be used by the text data type consistently
between Python 2 and 3 because <code class="docutils literal"><span class="pre">str</span></code> in Python 3 doesn&#8217;t have the method). Do
note that as of Python 3.5 the <code class="docutils literal"><span class="pre">__mod__</span></code> method was added to the bytes type.</p>
<table border="1" class="docutils">
<colgroup>
<col width="53%" />
<col width="47%" />
</colgroup>
<tbody valign="top">
<tr class="row-odd"><td><strong>Text data</strong></td>
<td><strong>Binary data</strong></td>
</tr>
<tr class="row-even"><td></td>
<td>decode</td>
</tr>
<tr class="row-odd"><td>encode</td>
<td>&nbsp;</td>
</tr>
<tr class="row-even"><td>format</td>
<td>&nbsp;</td>
</tr>
<tr class="row-odd"><td>isdecimal</td>
<td>&nbsp;</td>
</tr>
<tr class="row-even"><td>isnumeric</td>
<td>&nbsp;</td>
</tr>
</tbody>
</table>
<p>Making the distinction easier to handle can be accomplished by encoding and
decoding between binary data and text at the edge of your code. This means that
when you receive text in binary data, you should immediately decode it. And if
your code needs to send text as binary data then encode it as late as possible.
This allows your code to work with only text internally and thus eliminates
having to keep track of what type of data you are working with.</p>
<p>The next issue is making sure you know whether the string literals in your code
represent text or binary data. At minimum you should add a <code class="docutils literal"><span class="pre">b</span></code> prefix to any
literal that presents binary data. For text you should either use the
<code class="docutils literal"><span class="pre">from</span> <span class="pre">__future__</span> <span class="pre">import</span> <span class="pre">unicode_literals</span></code> statement or add a <code class="docutils literal"><span class="pre">u</span></code> prefix to
the text literal.</p>
<p>As part of this dichotomy you also need to be careful about opening files.
Unless you have been working on Windows, there is a chance you have not always
bothered to add the <code class="docutils literal"><span class="pre">b</span></code> mode when opening a binary file (e.g., <code class="docutils literal"><span class="pre">rb</span></code> for
binary reading).  Under Python 3, binary files and text files are clearly
distinct and mutually incompatible; see the <a class="reference internal" href="../library/io.html#module-io" title="io: Core tools for working with streams."><code class="xref py py-mod docutils literal"><span class="pre">io</span></code></a> module for details.
Therefore, you <strong>must</strong> make a decision of whether a file will be used for
binary access (allowing to read and/or write binary data) or text access
(allowing to read and/or write text data). You should also use <a class="reference internal" href="../library/io.html#io.open" title="io.open"><code class="xref py py-func docutils literal"><span class="pre">io.open()</span></code></a>
for opening files instead of the built-in <a class="reference internal" href="../library/functions.html#open" title="open"><code class="xref py py-func docutils literal"><span class="pre">open()</span></code></a> function as the <a class="reference internal" href="../library/io.html#module-io" title="io: Core tools for working with streams."><code class="xref py py-mod docutils literal"><span class="pre">io</span></code></a>
module is consistent from Python 2 to 3 while the built-in <a class="reference internal" href="../library/functions.html#open" title="open"><code class="xref py py-func docutils literal"><span class="pre">open()</span></code></a> function
is not (in Python 3 it&#8217;s actually <a class="reference internal" href="../library/io.html#io.open" title="io.open"><code class="xref py py-func docutils literal"><span class="pre">io.open()</span></code></a>).</p>
<p>The constructors of both <code class="docutils literal"><span class="pre">str</span></code> and <code class="docutils literal"><span class="pre">bytes</span></code> have different semantics for the
same arguments between Python 2 &amp; 3. Passing an integer to <code class="docutils literal"><span class="pre">bytes</span></code> in Python 2
will give you the string representation of the integer: <code class="docutils literal"><span class="pre">bytes(3)</span> <span class="pre">==</span> <span class="pre">'3'</span></code>.
But in Python 3, an integer argument to <code class="docutils literal"><span class="pre">bytes</span></code> will give you a bytes object
as long as the integer specified, filled with null bytes:
<code class="docutils literal"><span class="pre">bytes(3)</span> <span class="pre">==</span> <span class="pre">b'\x00\x00\x00'</span></code>. A similar worry is necessary when passing a
bytes object to <code class="docutils literal"><span class="pre">str</span></code>. In Python 2 you just get the bytes object back:
<code class="docutils literal"><span class="pre">str(b'3')</span> <span class="pre">==</span> <span class="pre">b'3'</span></code>. But in Python 3 you get the string representation of the
bytes object: <code class="docutils literal"><span class="pre">str(b'3')</span> <span class="pre">==</span> <span class="pre">&quot;b'3'&quot;</span></code>.</p>
<p>Finally, the indexing of binary data requires careful handling (slicing does
<strong>not</strong> require any special handling). In Python 2,
<code class="docutils literal"><span class="pre">b'123'[1]</span> <span class="pre">==</span> <span class="pre">b'2'</span></code> while in Python 3 <code class="docutils literal"><span class="pre">b'123'[1]</span> <span class="pre">==</span> <span class="pre">50</span></code>. Because binary data
is simply a collection of binary numbers, Python 3 returns the integer value for
the byte you index on. But in Python 2 because <code class="docutils literal"><span class="pre">bytes</span> <span class="pre">==</span> <span class="pre">str</span></code>, indexing
returns a one-item slice of bytes. The <a class="reference external" href="https://pypi.python.org/pypi/six">six</a> project has a function
named <code class="docutils literal"><span class="pre">six.indexbytes()</span></code> which will return an integer like in Python 3:
<code class="docutils literal"><span class="pre">six.indexbytes(b'123',</span> <span class="pre">1)</span></code>.</p>
<p>To summarize:</p>
<ol class="arabic simple">
<li>Decide which of your APIs take text and which take binary data</li>
<li>Make sure that your code that works with text also works with <code class="docutils literal"><span class="pre">unicode</span></code> and
code for binary data works with <code class="docutils literal"><span class="pre">bytes</span></code> in Python 2 (see the table above
for what methods you cannot use for each type)</li>
<li>Mark all binary literals with a <code class="docutils literal"><span class="pre">b</span></code> prefix, use a <code class="docutils literal"><span class="pre">u</span></code> prefix or
<a class="reference internal" href="../library/__future__.html#module-__future__" title="__future__: Future statement definitions"><code class="xref py py-mod docutils literal"><span class="pre">__future__</span></code></a> import statement for text literals</li>
<li>Decode binary data to text as soon as possible, encode text as binary data as
late as possible</li>
<li>Open files using <a class="reference internal" href="../library/io.html#io.open" title="io.open"><code class="xref py py-func docutils literal"><span class="pre">io.open()</span></code></a> and make sure to specify the <code class="docutils literal"><span class="pre">b</span></code> mode when
appropriate</li>
<li>Be careful when indexing binary data</li>
</ol>
</div>
</div>
<div class="section" id="prevent-compatibility-regressions">
<h3>Prevent compatibility regressions<a class="headerlink" href="#prevent-compatibility-regressions" title="Permalink to this headline">¶</a></h3>
<p>Once you have fully translated your code to be compatible with Python 3, you
will want to make sure your code doesn&#8217;t regress and stop working under
Python 3. This is especially true if you have a dependency which is blocking you
from actually running under Python 3 at the moment.</p>
<p>To help with staying compatible, any new modules you create should have
at least the following block of code at the top of it:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="kn">from</span> <span class="nn">__future__</span> <span class="k">import</span> <span class="n">absolute_import</span>
<span class="kn">from</span> <span class="nn">__future__</span> <span class="k">import</span> <span class="n">division</span>
<span class="kn">from</span> <span class="nn">__future__</span> <span class="k">import</span> <span class="n">print_function</span>
<span class="kn">from</span> <span class="nn">__future__</span> <span class="k">import</span> <span class="n">unicode_literals</span>
</pre></div>
</div>
<p>You can also run Python 2 with the <code class="docutils literal"><span class="pre">-3</span></code> flag to be warned about various
compatibility issues your code triggers during execution. If you turn warnings
into errors with <code class="docutils literal"><span class="pre">-Werror</span></code> then you can make sure that you don&#8217;t accidentally
miss a warning.</p>
<p>You can also use the <a class="reference external" href="https://pypi.python.org/pypi/pylint">Pylint</a> project and its <code class="docutils literal"><span class="pre">--py3k</span></code> flag to lint your code
to receive warnings when your code begins to deviate from Python 3
compatibility. This also prevents you from having to run <a class="reference external" href="http://python-modernize.readthedocs.org/en/latest/">Modernize</a> or <a class="reference external" href="http://python-future.org/automatic_conversion.html">Futurize</a>
over your code regularly to catch compatibility regressions. This does require
you only support Python 2.7 and Python 3.4 or newer as that is Pylint&#8217;s
minimum Python version support.</p>
</div>
<div class="section" id="check-which-dependencies-block-your-transition">
<h3>Check which dependencies block your transition<a class="headerlink" href="#check-which-dependencies-block-your-transition" title="Permalink to this headline">¶</a></h3>
<p><strong>After</strong> you have made your code compatible with Python 3 you should begin to
care about whether your dependencies have also been ported. The <a class="reference external" href="https://pypi.python.org/pypi/caniusepython3">caniusepython3</a>
project was created to help you determine which projects
&#8211; directly or indirectly &#8211; are blocking you from supporting Python 3. There
is both a command-line tool as well as a web interface at
<a class="reference external" href="https://caniusepython3.com">https://caniusepython3.com</a> .</p>
<p>The project also provides code which you can integrate into your test suite so
that you will have a failing test when you no longer have dependencies blocking
you from using Python 3. This allows you to avoid having to manually check your
dependencies and to be notified quickly when you can start running on Python 3.</p>
</div>
<div class="section" id="update-your-setup-py-file-to-denote-python-3-compatibility">
<h3>Update your <code class="docutils literal"><span class="pre">setup.py</span></code> file to denote Python 3 compatibility<a class="headerlink" href="#update-your-setup-py-file-to-denote-python-3-compatibility" title="Permalink to this headline">¶</a></h3>
<p>Once your code works under Python 3, you should update the classifiers in
your <code class="docutils literal"><span class="pre">setup.py</span></code> to contain <code class="docutils literal"><span class="pre">Programming</span> <span class="pre">Language</span> <span class="pre">::</span> <span class="pre">Python</span> <span class="pre">::</span> <span class="pre">3</span></code> and to not
specify sole Python 2 support. This will tell
anyone using your code that you support Python 2 <strong>and</strong> 3. Ideally you will
also want to add classifiers for each major/minor version of Python you now
support.</p>
</div>
<div class="section" id="use-continuous-integration-to-stay-compatible">
<h3>Use continuous integration to stay compatible<a class="headerlink" href="#use-continuous-integration-to-stay-compatible" title="Permalink to this headline">¶</a></h3>
<p>Once you are able to fully run under Python 3 you will want to make sure your
code always works under both Python 2 &amp; 3. Probably the best tool for running
your tests under multiple Python interpreters is <a class="reference external" href="https://pypi.python.org/pypi/tox">tox</a>. You can then integrate
tox with your continuous integration system so that you never accidentally break
Python 2 or 3 support.</p>
<p>You may also want to use use the <code class="docutils literal"><span class="pre">-bb</span></code> flag with the Python 3 interpreter to
trigger an exception when you are comparing bytes to strings or bytes to an int
(the latter is available starting in Python 3.5). By default type-differing
comparisons simply return <code class="docutils literal"><span class="pre">False</span></code>, but if you made a mistake in your
separation of text/binary data handling or indexing on bytes you wouldn&#8217;t easily
find the mistake. This flag will raise an exception when these kinds of
comparisons occur, making the mistake much easier to track down.</p>
<p>And that&#8217;s mostly it! At this point your code base is compatible with both
Python 2 and 3 simultaneously. Your testing will also be set up so that you
don&#8217;t accidentally break Python 2 or 3 compatibility regardless of which version
you typically run your tests under while developing.</p>
</div>
</div>
<div class="section" id="dropping-python-2-support-completely">
<h2>Dropping Python 2 support completely<a class="headerlink" href="#dropping-python-2-support-completely" title="Permalink to this headline">¶</a></h2>
<p>If you are able to fully drop support for Python 2, then the steps required
to transition to Python 3 simplify greatly.</p>
<ol class="arabic simple">
<li>Update your code to only support Python 2.7</li>
<li>Make sure you have good test coverage (<a class="reference external" href="https://pypi.python.org/pypi/coverage">coverage.py</a> can help)</li>
<li>Learn the differences between Python 2 &amp; 3</li>
<li>Use <a class="reference external" href="https://docs.python.org/3/library/2to3.html">2to3</a> to rewrite your code to run only under Python 3</li>
</ol>
<p>After this your code will be fully Python 3 compliant but in a way that is not
supported by Python 2. You should also update the classifiers in your
<code class="docutils literal"><span class="pre">setup.py</span></code> to contain <code class="docutils literal"><span class="pre">Programming</span> <span class="pre">Language</span> <span class="pre">::</span> <span class="pre">Python</span> <span class="pre">::</span> <span class="pre">3</span> <span class="pre">::</span> <span class="pre">Only</span></code>.</p>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../contents.html">Table Of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">Porting Python 2 Code to Python 3</a><ul>
<li><a class="reference internal" href="#the-short-explanation">The Short Explanation</a></li>
<li><a class="reference internal" href="#details">Details</a><ul>
<li><a class="reference internal" href="#drop-support-for-python-2-6-and-older">Drop support for Python 2.6 and older</a></li>
<li><a class="reference internal" href="#make-sure-you-specify-the-proper-version-support-in-your-setup-py-file">Make sure you specify the proper version support in your <code class="docutils literal"><span class="pre">setup.py</span></code> file</a></li>
<li><a class="reference internal" href="#have-good-test-coverage">Have good test coverage</a></li>
<li><a class="reference internal" href="#learn-the-differences-between-python-2-3">Learn the differences between Python 2 &amp; 3</a></li>
<li><a class="reference internal" href="#update-your-code">Update your code</a><ul>
<li><a class="reference internal" href="#division">Division</a></li>
<li><a class="reference internal" href="#text-versus-binary-data">Text versus binary data</a></li>
</ul>
</li>
<li><a class="reference internal" href="#prevent-compatibility-regressions">Prevent compatibility regressions</a></li>
<li><a class="reference internal" href="#check-which-dependencies-block-your-transition">Check which dependencies block your transition</a></li>
<li><a class="reference internal" href="#update-your-setup-py-file-to-denote-python-3-compatibility">Update your <code class="docutils literal"><span class="pre">setup.py</span></code> file to denote Python 3 compatibility</a></li>
<li><a class="reference internal" href="#use-continuous-integration-to-stay-compatible">Use continuous integration to stay compatible</a></li>
</ul>
</li>
<li><a class="reference internal" href="#dropping-python-2-support-completely">Dropping Python 2 support completely</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="index.html"
                        title="previous chapter">Python HOWTOs</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="cporting.html"
                        title="next chapter">Porting Extension Modules to Python 3</a></p>
<h3>This Page</h3>
<ul class="this-page-menu">
  <li><a href="../bugs.html">Report a Bug</a></li>
  <li><a href="../_sources/howto/pyporting.txt"
         rel="nofollow">Show Source</a></li>
</ul>

<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="cporting.html" title="Porting Extension Modules to Python 3"
             >next</a> |</li>
        <li class="right" >
          <a href="index.html" title="Python HOWTOs"
             >previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >Python HOWTOs</a> &raquo;</li> 
      </ul>
    </div>  
    <div class="footer">
    &copy; <a href="../copyright.html">Copyright</a> 1990-2016, Python Software Foundation.
    <br />
    The Python Software Foundation is a non-profit corporation.
    <a href="https://www.python.org/psf/donations/">Please donate.</a>
    <br />
    Last updated on Jan 08, 2016.
    <a href="../bugs.html">Found a bug</a>?
    <br />
    Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.3.3.
    </div>

  </body>
</html>